/*
 * Copyright (c) 2012 NINTENDO.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions, and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions, and the following disclaimer in the 
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY NINTENDO AND ITS CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL NINTENDO OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef JS_CAMERA_EXTENSION_H
#define JS_CAMERA_EXTENSION_H

#include <wtf/Platform.h> // PLATFORM(...)

#include <APICast.h>
#include <JSObjectRef.h>
#include <string>
#include "JSExtensionData.h"

#if !PLATFORM(WIIU)
typedef unsigned int u32;
#endif

	class JSCameraExtension
	{
	public:
		JSCameraExtension();
		~JSCameraExtension();
		void init(JSGlobalContextRef context, JSObjectRef package);
	private:
		JSClassDefinition jsClass;
		JSClassRef classRef;
	};

	class JSCameraEventListener : public JSExtensionEventListener
	{
	public:
		JSCameraEventListener();
		~JSCameraEventListener();
		
		virtual void OnEvent(JSEvent js_event);
		virtual std::string ToString(void);
	};

	struct JSCameraExtensionData: JSExtensionData
	{
		JSObjectRef capabilities;
		u32 currentFPS;
		u32 id;
		u32 imageStream;
		bool isReady;
		std::string name;		
	};

#endif
